import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ShopGoodsCoupon, ShopGoodsCouponParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品优惠券表
 */
export async function pageShopGoodsCoupon(params: ShopGoodsCouponParam) {
  const res = await request.get<ApiResult<PageResult<ShopGoodsCoupon>>>(
    MODULES_API_URL + '/shop/shop-goods-coupon/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品优惠券表列表
 */
export async function listShopGoodsCoupon(params?: ShopGoodsCouponParam) {
  const res = await request.get<ApiResult<ShopGoodsCoupon[]>>(
    MODULES_API_URL + '/shop/shop-goods-coupon',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品优惠券表
 */
export async function addShopGoodsCoupon(data: ShopGoodsCoupon) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-goods-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品优惠券表
 */
export async function updateShopGoodsCoupon(data: ShopGoodsCoupon) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-goods-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品优惠券表
 */
export async function removeShopGoodsCoupon(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-goods-coupon/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品优惠券表
 */
export async function removeBatchShopGoodsCoupon(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-goods-coupon/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品优惠券表
 */
export async function getShopGoodsCoupon(id: number) {
  const res = await request.get<ApiResult<ShopGoodsCoupon>>(
    MODULES_API_URL + '/shop/shop-goods-coupon/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
